#ifndef _DECL_arrayring_H_
#define _DECL_arrayring_H_
#include "charm++.h"
/* DECLS: message arrayMessage;
 */
class arrayMessage;
class CMessage_arrayMessage:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){CkFreeMsg(p);}
    void operator delete(void*p){ CkFreeMsg(p);}
    void operator delete(void*p, int*, const int){CkFreeMsg(p);}
    void operator delete(void*p, int*){CkFreeMsg(p);}
#endif
    void operator delete(void*p, size_t){CkFreeMsg(p);}
    static void* alloc(int,size_t, int*, int);
    CMessage_arrayMessage() {};
    static void *pack(arrayMessage *p);
    static arrayMessage* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){CkFreeMsg(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: array arrayRing_array: ArrayElement{
arrayRing_array(CkMigrateMessage* impl_msg);
arrayRing_array(void);
void start(arrayMessage* impl_msg);
};
 */
 class arrayRing_array;
 class CkIndex_arrayRing_array;
 class CProxy_arrayRing_array;
 class CProxyElement_arrayRing_array;
 class CProxySection_arrayRing_array;
/* --------------- index object ------------------ */
class CkIndex_arrayRing_array:public CProxyElement_ArrayElement{
  public:
    typedef arrayRing_array local_t;
    typedef CkIndex_arrayRing_array index_t;
    typedef CProxy_arrayRing_array proxy_t;
    typedef CProxyElement_arrayRing_array element_t;
    typedef CProxySection_arrayRing_array section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: arrayRing_array(CkMigrateMessage* impl_msg);
 */
    static int __idx_arrayRing_array_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_arrayRing_array_CkMigrateMessage; }
    static void _call_arrayRing_array_CkMigrateMessage(void* impl_msg,arrayRing_array* impl_obj);

/* DECLS: arrayRing_array(void);
 */
    static int __idx_arrayRing_array_void;
    static int ckNew(void) { return __idx_arrayRing_array_void; }
    static void _call_arrayRing_array_void(void* impl_msg,arrayRing_array* impl_obj);

/* DECLS: void start(arrayMessage* impl_msg);
 */
    static int __idx_start_arrayMessage;
    static int start(arrayMessage* impl_msg) { return __idx_start_arrayMessage; }
    static void _call_start_arrayMessage(void* impl_msg,arrayRing_array* impl_obj);
};
/* --------------- element proxy ------------------ */
 class CProxyElement_arrayRing_array : public CProxyElement_ArrayElement{
  public:
    typedef arrayRing_array local_t;
    typedef CkIndex_arrayRing_array index_t;
    typedef CProxy_arrayRing_array proxy_t;
    typedef CProxyElement_arrayRing_array element_t;
    typedef CProxySection_arrayRing_array section_t;

    CProxyElement_arrayRing_array(void) {}
    CProxyElement_arrayRing_array(const ArrayElement *e) : CProxyElement_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_ELEMENT(CProxyElement_ArrayElement)
    arrayRing_array *ckLocal(void) const
      { return (arrayRing_array *)CProxyElement_ArrayElement::ckLocal(); }
    CProxyElement_arrayRing_array(const CkArrayID &aid,const CkArrayIndex1D &idx,CK_DELCTOR_PARAM)
        :CProxyElement_ArrayElement(aid,idx,CK_DELCTOR_ARGS) {}
    CProxyElement_arrayRing_array(const CkArrayID &aid,const CkArrayIndex1D &idx)
        :CProxyElement_ArrayElement(aid,idx) {}
/* DECLS: arrayRing_array(CkMigrateMessage* impl_msg);
 */

/* DECLS: arrayRing_array(void);
 */
    void insert(int onPE=-1);
/* DECLS: void start(arrayMessage* impl_msg);
 */
    void start(arrayMessage* impl_msg) ;
};
PUPmarshall(CProxyElement_arrayRing_array);
/* ---------------- collective proxy -------------- */
 class CProxy_arrayRing_array : public CProxy_ArrayElement{
  public:
    typedef arrayRing_array local_t;
    typedef CkIndex_arrayRing_array index_t;
    typedef CProxy_arrayRing_array proxy_t;
    typedef CProxyElement_arrayRing_array element_t;
    typedef CProxySection_arrayRing_array section_t;

    CProxy_arrayRing_array(void) {}
    CProxy_arrayRing_array(const ArrayElement *e) : CProxy_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY(CProxy_ArrayElement)
    static CkArrayID ckNew(void) {return ckCreateEmptyArray();}
//Generalized array indexing:
    CProxyElement_arrayRing_array operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_arrayRing_array(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_arrayRing_array operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_arrayRing_array(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_arrayRing_array operator [] (int idx) const 
        {return CProxyElement_arrayRing_array(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxyElement_arrayRing_array operator () (int idx) const 
        {return CProxyElement_arrayRing_array(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxy_arrayRing_array(const CkArrayID &aid,CK_DELCTOR_PARAM) 
        :CProxy_ArrayElement(aid,CK_DELCTOR_ARGS) {}
    CProxy_arrayRing_array(const CkArrayID &aid) 
        :CProxy_ArrayElement(aid) {}
/* DECLS: arrayRing_array(CkMigrateMessage* impl_msg);
 */

/* DECLS: arrayRing_array(void);
 */
    static CkArrayID ckNew(const CkArrayOptions &opts);
    static CkArrayID ckNew(const int s1);

/* DECLS: void start(arrayMessage* impl_msg);
 */
    void start(arrayMessage* impl_msg) ;
};
PUPmarshall(CProxy_arrayRing_array);
/* ---------------- section proxy -------------- */
 class CProxySection_arrayRing_array : public CProxySection_ArrayElement{
  public:
    typedef arrayRing_array local_t;
    typedef CkIndex_arrayRing_array index_t;
    typedef CProxy_arrayRing_array proxy_t;
    typedef CProxyElement_arrayRing_array element_t;
    typedef CProxySection_arrayRing_array section_t;

    CProxySection_arrayRing_array(void) {}
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxySection_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxySection_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_SECTION(CProxySection_ArrayElement)
//Generalized array indexing:
    CProxyElement_arrayRing_array operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_arrayRing_array(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_arrayRing_array operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_arrayRing_array(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_arrayRing_array operator [] (int idx) const 
        {return CProxyElement_arrayRing_array(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    CProxyElement_arrayRing_array operator () (int idx) const 
        {return CProxyElement_arrayRing_array(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndex1D *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
    static CkSectionID ckNew(const CkArrayID &aid, int l, int u, int s) {
      CkVec<CkArrayIndex1D> al;
      for (int i=l; i<=u; i+=s) al.push_back(CkArrayIndex1D(i));
      return CkSectionID(aid, al.getVec(), al.size());
    } 
    CProxySection_arrayRing_array(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems, CK_DELCTOR_PARAM) 
        :CProxySection_ArrayElement(aid,elems,nElems,CK_DELCTOR_ARGS) {}
    CProxySection_arrayRing_array(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) 
        :CProxySection_ArrayElement(aid,elems,nElems) {}
    CProxySection_arrayRing_array(const CkSectionID &sid)       :CProxySection_ArrayElement(sid) {}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
/* DECLS: arrayRing_array(CkMigrateMessage* impl_msg);
 */

/* DECLS: arrayRing_array(void);
 */

/* DECLS: void start(arrayMessage* impl_msg);
 */
    void start(arrayMessage* impl_msg) ;
};
PUPmarshall(CProxySection_arrayRing_array);
typedef CBaseT<ArrayElementT<CkIndex1D>,CProxy_arrayRing_array>  CBase_arrayRing_array;

extern void _registerarrayring(void);
#endif
